Package com.saxonica.xqj.pull

## Class TreeWalker

- java.lang.Object
- - com.saxonica.xqj.pull.TreeWalker

- All Implemented Interfaces:
    `javax.xml.transform.SourceLocator`, `PullProvider`, `UnfailingPullProvider`, `Location`, `org.xml.sax.Locator`

      public class TreeWalker
      extends java.lang.Object
      implements UnfailingPullProvider, Location

  This implementation of the Saxon pull interface starts from any NodeInfo, and returns the events corresponding to that node and its descendants (including their attributes and namespaces). This works with any tree model: alternative implementations may be available that take advantage of particular implementations of the tree model.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.pull.PullProvider

      `PullProvider.Event`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the event reader.
    `PullProvider.Event` | `current()` | Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd().
    `AtomicValue` | `getAtomicValue()` | Get an atomic value.
    `AttributeMap` | `getAttributes()` | Get the attributes associated with the current element.
    `int` | `getColumnNumber()` | Return the character position where the current document event ends.
    `int` | `getLineNumber()` | Return the line number where the current document event ends.
    `NamePool` | `getNamePool()` | Get the namePool used to lookup all name codes and namespace codes
    `NamespaceBinding[]` | `getNamespaceDeclarations()` | Get the namespace declarations associated with the current element.
    `NodeName` | `getNodeName()` | Get the NodeName identifying the name of the current node.
    `PipelineConfiguration` | `getPipelineConfiguration()` | Get configuration information.
    `java.lang.String` | `getPublicId()` | Return the public identifier for the current document event.
    `SchemaType` | `getSchemaType()` | Get the type annotation of the current attribute or element node, or atomic value.
    `Location` | `getSourceLocator()` | Get the location of the current event.
    `java.lang.CharSequence` | `getStringValue()` | Get the string value of the current attribute, text node, processing-instruction, or atomic value.
    `java.lang.String` | `getSystemId()` | Return the system identifier for the current document event.
    `java.util.List<UnparsedEntity>` | `getUnparsedEntities()` | Get a list of unparsed entities.
    `static UnfailingPullProvider` | `makeTreeWalker​(NodeInfo startNode)` | Factory method to get a tree walker starting an a given node
    `PullProvider.Event` | `next()` | Get the next event
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setPipelineConfiguration​(PipelineConfiguration pipe)` | Set configuration information.
    `PullProvider.Event` | `skipToMatchingEnd()` | Skip the current subtree.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### makeTreeWalker

          public static UnfailingPullProvider makeTreeWalker​(NodeInfo startNode)

      Factory method to get a tree walker starting an a given node
      Parameters:
        `startNode` - the start node
      Returns:
        a PullProvider that delivers events associated with the subtree starting at the given node

    - #### setPipelineConfiguration

          public void setPipelineConfiguration​(PipelineConfiguration pipe)

      Set configuration information. This must only be called before any events have been read.
      Specified by:
        `setPipelineConfiguration` in interface `PullProvider`
      Parameters:
        `pipe` - the pipeline configuration

    - #### getPipelineConfiguration

          public PipelineConfiguration getPipelineConfiguration()

      Get configuration information.
      Specified by:
        `getPipelineConfiguration` in interface `PullProvider`
      Returns:
        the pipeline configuration

    - #### next

          public PullProvider.Event next()
                                  throws XPathException

      Get the next event
      Specified by:
        `next` in interface `PullProvider`
      Specified by:
        `next` in interface `UnfailingPullProvider`
      Returns:
        an Event object indicating the type of event. The code `PullProvider.Event.END_OF_INPUT` is returned if there are no more events to return.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### current

          public PullProvider.Event current()

      Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd(). This method does not change the position of the PullProvider.
      Specified by:
        `current` in interface `PullProvider`
      Specified by:
        `current` in interface `UnfailingPullProvider`
      Returns:
        the current event

    - #### getAttributes

          public AttributeMap getAttributes()

      Get the attributes associated with the current element. This method must be called only after a START_ELEMENT event has been notified. The contents of the returned AttributeMap are immutable.

      Attributes may be read before or after reading the namespaces of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

      Specified by:
        `getAttributes` in interface `PullProvider`
      Specified by:
        `getAttributes` in interface `UnfailingPullProvider`
      Returns:
        an AttributeMap representing the attributes of the element that has just been notified.

    - #### getNamespaceDeclarations

          public NamespaceBinding[] getNamespaceDeclarations()

      Get the namespace declarations associated with the current element. This method must be called only after a START_ELEMENT event has been notified. In the case of a top-level START_ELEMENT event (that is, an element that either has no parent node, or whose parent is not included in the sequence being read), the NamespaceDeclarations object returned will contain a namespace declaration for each namespace that is in-scope for this element node. In the case of a non-top-level element, the NamespaceDeclarations will contain a set of namespace declarations and undeclarations, representing the differences between this element and its parent.

      It is permissible for this method to return namespace declarations that are redundant.

      The NamespaceDeclarations object is guaranteed to remain unchanged until the next START_ELEMENT event, but may then be overwritten. The object should not be modified by the client.

      Namespaces may be read before or after reading the attributes of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

      Specified by:
        `getNamespaceDeclarations` in interface `PullProvider`
      Specified by:
        `getNamespaceDeclarations` in interface `UnfailingPullProvider`
      Returns:
        the namespace declarations associated with the current START_ELEMENT event.

    - #### skipToMatchingEnd

          public PullProvider.Event skipToMatchingEnd()

      Skip the current subtree. This method may be called only immediately after a START_DOCUMENT or START_ELEMENT event. This call returns the matching END_DOCUMENT or END_ELEMENT event; the next call on next() will return the event following the END_DOCUMENT or END_ELEMENT.
      Specified by:
        `skipToMatchingEnd` in interface `PullProvider`
      Specified by:
        `skipToMatchingEnd` in interface `UnfailingPullProvider`
      Returns:
        the matching END_DOCUMENT or END_ELEMENT event

    - #### close

          public void close()

      Close the event reader. This indicates that no further events are required. It is not necessary to close an event reader after `PullProvider.Event.END_OF_INPUT` has been reported, but it is recommended to close it if reading terminates prematurely. Once an event reader has been closed, the effect of further calls on next() is undefined.
      Specified by:
        `close` in interface `PullProvider`
      Specified by:
        `close` in interface `UnfailingPullProvider`

    - #### getNamePool

          public NamePool getNamePool()

      Get the namePool used to lookup all name codes and namespace codes
      Returns:
        the namePool

    - #### getNodeName

          public NodeName getNodeName()

      Get the NodeName identifying the name of the current node. This method can be used after the `PullProvider.Event.START_ELEMENT`, `PullProvider.Event.PROCESSING_INSTRUCTION`, `PullProvider.Event.ATTRIBUTE`, or `PullProvider.Event.NAMESPACE` events. With some PullProvider implementations, it can also be used after `PullProvider.Event.END_ELEMENT`, but this is not guaranteed: a client who requires the information at that point (for example, to do serialization) should insert an `ElementNameTracker` into the pipeline. If called at other times, the result is undefined and may result in an IllegalStateException. If called when the current node is an unnamed namespace node (a node representing the default namespace) the returned value is null.
      Specified by:
        `getNodeName` in interface `PullProvider`
      Specified by:
        `getNodeName` in interface `UnfailingPullProvider`
      Returns:
        the NodeName. The NodeName can be used to obtain the prefix, local name, and namespace URI.

    - #### getStringValue

          public java.lang.CharSequence getStringValue()

      Get the string value of the current attribute, text node, processing-instruction, or atomic value. This method cannot be used to obtain the string value of an element, or of a namespace node. If the most recent event was anything other than `PullProvider.Event.START_ELEMENT`, `PullProvider.Event.TEXT`, `PullProvider.Event.PROCESSING_INSTRUCTION`, or `PullProvider.Event.ATOMIC_VALUE`, the result is undefined.
      Specified by:
        `getStringValue` in interface `PullProvider`
      Specified by:
        `getStringValue` in interface `UnfailingPullProvider`
      Returns:
        the String Value of the node in question, defined according to the rules in the XPath data model.

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of the current attribute or element node, or atomic value. The result of this method is undefined unless the most recent event was START_ELEMENT, START_CONTENT, ATTRIBUTE, or ATOMIC_VALUE.
      Specified by:
        `getSchemaType` in interface `PullProvider`
      Specified by:
        `getSchemaType` in interface `UnfailingPullProvider`
      Returns:
        the type code.

    - #### getAtomicValue

          public AtomicValue getAtomicValue()

      Get an atomic value. This call may be used only when the last event reported was ATOMIC_VALUE. This indicates that the PullProvider is reading a sequence that contains a free-standing atomic value; it is never used when reading the content of a node.
      Specified by:
        `getAtomicValue` in interface `PullProvider`
      Specified by:
        `getAtomicValue` in interface `UnfailingPullProvider`
      Returns:
        the atomic value

    - #### getSourceLocator

          public Location getSourceLocator()

      Get the location of the current event. For an event stream representing a real document, the location information should identify the location in the lexical XML source. For a constructed document, it should identify the location in the query or stylesheet that caused the node to be created. A value of null can be returned if no location information is available.
      Specified by:
        `getSourceLocator` in interface `PullProvider`
      Specified by:
        `getSourceLocator` in interface `UnfailingPullProvider`
      Returns:
        the SourceLocator giving the location of the current event, or null if no location information is available

    - #### getPublicId

          public java.lang.String getPublicId()

      Return the public identifier for the current document event.

      The return value is the public identifier of the document entity or of the external parsed entity in which the markup that triggered the event appears.

      Specified by:
        `getPublicId` in interface `Location`
      Specified by:
        `getPublicId` in interface `org.xml.sax.Locator`
      Specified by:
        `getPublicId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        A string containing the public identifier, or null if none is available.
      See Also:
        `getSystemId()`

    - #### getSystemId

          public java.lang.String getSystemId()

      Return the system identifier for the current document event.

      The return value is the system identifier of the document entity or of the external parsed entity in which the markup that triggered the event appears.

      If the system identifier is a URL, the parser must resolve it fully before passing it to the application.

      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        A string containing the system identifier, or null if none is available.
      See Also:
        `getPublicId()`

    - #### getLineNumber

          public int getLineNumber()

      Return the line number where the current document event ends.

      Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

      The return value is an approximation of the line number in the document entity or external parsed entity where the markup that triggered the event appears.

      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        The line number, or -1 if none is available.
      See Also:
        `getColumnNumber()`

    - #### getColumnNumber

          public int getColumnNumber()

      Return the character position where the current document event ends.

      Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

      The return value is an approximation of the column number in the document entity or external parsed entity where the markup that triggered the event appears.

      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        The column number, or -1 if none is available.
      See Also:
        `getLineNumber()`

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### getUnparsedEntities

          public java.util.List<UnparsedEntity> getUnparsedEntities()

      Get a list of unparsed entities.
      Specified by:
        `getUnparsedEntities` in interface `PullProvider`
      Specified by:
        `getUnparsedEntities` in interface `UnfailingPullProvider`
      Returns:
        a list of unparsed entities, or null if the information is not available, or an empty list if there are no unparsed entities.